2 ############################################################################
4 # This file is part of the IPFire Firewall. #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
20 # Copyright (C) 2007-2019 IPFire Team <info@ipfire.org>. #
22 ############################################################################
25 NAME
="IPFire" # Software name
26 SNAME
="ipfire" # Short name
27 # If you update the version don't forget to update backupiso and add it to core update
28 VERSION
="2.25" # Version number
29 CORE
="142" # Core Level (Filename)
30 PAKFIRE_CORE
="141" # Core Level (PAKFIRE)
31 SLOGAN
="www.ipfire.org" # Software slogan
32 CONFIG_ROOT
=/var
/ipfire
# Configuration rootdir
34 MAX_RETRIES
=1 # prefetch/check loop
35 BUILD_IMAGES
=1 # Flash and Xen Downloader
36 KVER
=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
38 # Information from Git
39 GIT_BRANCH
="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
40 GIT_TAG
="$(git tag | tail -1)" # Git Tag
41 GIT_LASTCOMMIT
="$(git rev-parse --verify HEAD)" # Last commit
45 ###############################################################################
47 # Beautifying variables & presentation & input output interface
49 ###############################################################################
51 # Remember if the shell is interactive or not
52 if [ -t 0 ] && [ -t 1 ]; then
58 # Sets or adjusts pretty formatting variables
61 # Find current screen size
64 # When using remote connections, such as a serial port, stty size returns 0
65 if ! ${INTERACTIVE} ||
[ "${COLUMNS}" = "0" ]; then
69 # Measurements for positioning result messages
73 NAME_WIDTH
=$
(( COLUMNS
- OPTIONS_WIDTH
- TIME_WIDTH
- STATUS_WIDTH
))
74 LINE_WIDTH
=$
(( COLUMNS
- STATUS_WIDTH
))
76 TIME_COL
=$
(( NAME_WIDTH
+ OPTIONS_WIDTH
))
77 STATUS_COL
=$
(( TIME_COL
+ TIME_WIDTH
))
80 # Initially setup terminal
83 # Call resize_terminal when terminal is being resized
84 trap "resize_terminal" WINCH
86 # Define color for messages
94 # New architecture variables
95 HOST_ARCH
="$(uname -m)"
98 BASENAME
=$
(basename $0)
100 # Debian specific settings
101 if [ ! -e /etc
/debian_version
]; then
104 if [ -x /usr
/bin
/realpath
]; then
105 FULLPATH
=`/usr/bin/realpath $0`
107 echo "ERROR: Need to do apt-get install realpath"
112 # This is the directory where make.sh is in
113 export BASEDIR
=$
(echo $FULLPATH |
sed "s/\/$BASENAME//g")
115 LOGFILE
=$BASEDIR/log
/_build.preparation.log
117 DIR_CHK
=$BASEDIR/cache
/check
118 mkdir
$BASEDIR/log
/ 2>/dev
/null
120 system_processors
() {
121 getconf _NPROCESSORS_ONLN
2>/dev
/null ||
echo "1"
127 while read -r key val unit
; do
131 echo "$(( ${val} / 1024 ))"
139 local build_arch
="${1}"
141 if [ "${build_arch}" = "default" ]; then
142 build_arch
="$(configure_build_guess)"
145 case "${build_arch}" in
147 BUILDTARGET
="${build_arch}-unknown-linux-gnu"
148 CROSSTARGET
="${build_arch}-cross-linux-gnu"
150 CFLAGS_ARCH
="-m64 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic"
154 BUILDTARGET
="${build_arch}-pc-linux-gnu"
155 CROSSTARGET
="${build_arch}-cross-linux-gnu"
157 CFLAGS_ARCH
="-march=i586 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic -fomit-frame-pointer"
161 BUILDTARGET
="${build_arch}-unknown-linux-gnu"
162 CROSSTARGET
="${build_arch}-cross-linux-gnu"
168 BUILDTARGET
="${build_arch}-unknown-linux-gnueabi"
169 CROSSTARGET
="${build_arch}-cross-linux-gnueabi"
171 CFLAGS_ARCH
="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
175 BUILDTARGET
="${build_arch}-unknown-linux-gnueabi"
176 CROSSTARGET
="${build_arch}-cross-linux-gnueabi"
178 CFLAGS_ARCH
="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
179 RUSTFLAGS
="-Ccodegen-units=1"
183 exiterror
"Cannot build for architure ${build_arch}"
187 # Check if the QEMU helper is available if needed.
188 if qemu_is_required
"${build_arch}"; then
189 local qemu_build_helper
="$(qemu_find_build_helper_name "${build_arch}")"
191 if [ -n "${qemu_build_helper}" ]; then
192 QEMU_TARGET_HELPER
="${qemu_build_helper}"
194 exiterror
"Could not find a binfmt_misc helper entry for ${build_arch}"
198 BUILD_ARCH
="${build_arch}"
199 TOOLS_DIR
="/tools_${BUILD_ARCH}"
202 HARDENING_CFLAGS
="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
204 CFLAGS
="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
207 # Determine parallelism
208 # We assume that each process consumes about
209 # 128MB of memory. Therefore we find out how
210 # many processes fit into memory.
211 local mem_max
=$
(( ${SYSTEM_MEMORY} / 128 ))
212 local cpu_max
=$
(( ${SYSTEM_PROCESSORS} + 1 ))
215 if [ ${mem_max} -lt ${cpu_max} ]; then
216 parallelism
=${mem_max}
218 parallelism
=${cpu_max}
221 # Use this as default PARALLELISM
222 DEFAULT_PARALLELISM
="${parallelism}"
224 # Compression parameters
225 # We use mode 8 for reasonable memory usage when decompressing
226 # but with overall good compression
229 # We try to use as many cores as possible
230 XZ_OPT
="${XZ_OPT} -T0"
232 # We need to limit memory because XZ uses too much when running
233 # in parallel and it isn't very smart in limiting itself.
234 # We allow XZ to use up to 70% of all system memory.
235 local xz_memory
=$
(( SYSTEM_MEMORY
* 7 / 10 ))
237 # XZ memory cannot be larger than 2GB on 32 bit systems
238 case "${build_arch}" in
240 if [ ${xz_memory} -gt 2048 ]; then
246 XZ_OPT
="${XZ_OPT} --memory=${xz_memory}MiB"
249 configure_build_guess
() {
250 case "${HOST_ARCH}" in
262 armv7
*|armv6
*|armv5
*)
267 exiterror
"Cannot guess build architecture"
273 umount
$BASEDIR/build
/sys
2>/dev
/null
;
274 umount
$BASEDIR/build
/dev
/shm
2>/dev
/null
;
275 umount
$BASEDIR/build
/dev
/pts
2>/dev
/null
;
276 umount
$BASEDIR/build
/dev
2>/dev
/null
;
277 umount
$BASEDIR/build
/proc
2>/dev
/null
;
278 umount
$BASEDIR/build
/install
/mnt
2>/dev
/null
;
279 umount
$BASEDIR/build
/usr
/src
/cache
2>/dev
/null
;
280 umount
$BASEDIR/build
/usr
/src
/ccache
2>/dev
/null
;
281 umount
$BASEDIR/build
/usr
/src
/config
2>/dev
/null
;
282 umount
$BASEDIR/build
/usr
/src
/doc
2>/dev
/null
;
283 umount
$BASEDIR/build
/usr
/src
/html
2>/dev
/null
;
284 umount
$BASEDIR/build
/usr
/src
/langs
2>/dev
/null
;
285 umount
$BASEDIR/build
/usr
/src
/lfs
2>/dev
/null
;
286 umount
$BASEDIR/build
/usr
/src
/log
2>/dev
/null
;
287 umount
$BASEDIR/build
/usr
/src
/src
2>/dev
/null
;
288 umount
$BASEDIR/build
/usr
/src
2>/dev
/null
;
298 if [ ${seconds} -ge 3600 ]; then
299 printf "%d:%02d:%02d\n" \
300 "$(( seconds / 3600 ))" \
301 "$(( seconds % 3600 / 60 ))" \
302 "$(( seconds % 3600 % 60 ))"
303 elif [ ${seconds} -ge 60 ]; then
305 "$(( seconds / 60 ))" \
306 "$(( seconds % 60 ))"
308 printf "%d\n" "${seconds}"
315 printf "%-${LINE_WIDTH}s" "${line}"
322 if ${INTERACTIVE}; then
328 if ${INTERACTIVE}; then
334 _print_line BOLD
"$@"
338 _print_line FAIL
"$@"
345 local version
="$(grep -E "^VER |^VER
=|^VER
" $BASEDIR/lfs/${name} | awk '{ print $3 }')"
348 local string
="${name}"
349 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
350 string
="${string} (${version})"
353 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
354 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
358 local runtime
=$
(format_runtime $@
)
360 if ${INTERACTIVE}; then
361 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
363 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
370 local color
="${!status}"
372 if ${INTERACTIVE}; then
373 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
375 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
379 print_build_stage
() {
386 print_build_summary
() {
387 local runtime
=$
(format_runtime $@
)
389 print_line
"*** Build finished in ${runtime}"
395 for i
in `seq 0 7`; do
396 if ( losetup
/dev
/loop
${i} 2>/dev
/null |
grep -q "/install/images" ); then
397 losetup
-d /dev
/loop
${i} 2>/dev
/null
402 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
406 while read -r line
; do
408 done <<< "$(tail -n30 ${LOGFILE})"
414 for line
in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
415 print_error
"${line}"
423 # Are we running the right shell?
424 if [ -z "${BASH}" ]; then
425 exiterror
"BASH environment variable is not set. You're probably running the wrong shell."
428 if [ -z "${BASH_VERSION}" ]; then
429 exiterror
"Not running BASH shell."
432 # Trap on emergency exit
433 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
435 # Resetting our nice level
436 if ! renice
${NICE} $$
>/dev
/null
; then
437 exiterror
"Failed to set nice level to ${NICE}"
440 # Checking if running as root user
441 if [ $
(id
-u) -ne 0 ]; then
442 exiterror
"root privileges required for building"
445 # Checking for necessary temporary space
446 print_line
"Checking for necessary space on disk $BASE_DEV"
447 BASE_DEV
=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
448 BASE_ASPACE
=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
449 if (( 2048000 > $BASE_ASPACE )); then
450 BASE_USPACE
=`du -skx $BASEDIR | awk '{print $1}'`
451 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
453 exiterror
"Not enough temporary space available, need at least 2GB on $BASE_DEV"
468 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS
469 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
471 # Make some extra directories
472 mkdir
-p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev
/null
473 mkdir
-p $BASEDIR/build
/{etc
,usr
/src
} 2>/dev
/null
474 mkdir
-p $BASEDIR/build
/{dev
/{shm
,pts
},proc
,sys
}
475 mkdir
-p $BASEDIR/{cache
,ccache
/${BUILD_ARCH}} 2>/dev
/null
477 if [ "${ENABLE_RAMDISK}" = "on" ]; then
478 mkdir
-p $BASEDIR/build
/usr
/src
479 mount
-t tmpfs tmpfs
-o size
=4G
,nr_inodes
=1M
,mode
=1777 $BASEDIR/build
/usr
/src
482 mkdir
-p $BASEDIR/build
/usr
/src
/{cache
,config
,doc
,html
,langs
,lfs
,log
,src
,ccache
}
484 mknod
-m 600 $BASEDIR/build
/dev
/console c
5 1 2>/dev
/null
485 mknod
-m 666 $BASEDIR/build
/dev
/null c
1 3 2>/dev
/null
487 # Make all sources and proc available under lfs build
488 mount
--bind /dev
$BASEDIR/build
/dev
489 mount
--bind /dev
/pts
$BASEDIR/build
/dev
/pts
490 mount
--bind /dev
/shm
$BASEDIR/build
/dev
/shm
491 mount
--bind /proc
$BASEDIR/build
/proc
492 mount
--bind /sys
$BASEDIR/build
/sys
493 mount
--bind $BASEDIR/cache
$BASEDIR/build
/usr
/src
/cache
494 mount
--bind $BASEDIR/ccache
/${BUILD_ARCH} $BASEDIR/build
/usr
/src
/ccache
495 mount
--bind $BASEDIR/config
$BASEDIR/build
/usr
/src
/config
496 mount
--bind $BASEDIR/doc
$BASEDIR/build
/usr
/src
/doc
497 mount
--bind $BASEDIR/html
$BASEDIR/build
/usr
/src
/html
498 mount
--bind $BASEDIR/langs
$BASEDIR/build
/usr
/src
/langs
499 mount
--bind $BASEDIR/lfs
$BASEDIR/build
/usr
/src
/lfs
500 mount
--bind $BASEDIR/log
$BASEDIR/build
/usr
/src
/log
501 mount
--bind $BASEDIR/src
$BASEDIR/build
/usr
/src
/src
503 # Run LFS static binary creation scripts one by one
504 export CCACHE_DIR
=$BASEDIR/ccache
505 export CCACHE_COMPRESS
=1
506 export CCACHE_COMPILERCHECK
="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
508 # Remove pre-install list of installed files in case user erase some files before rebuild
509 rm -f $BASEDIR/build
/usr
/src
/lsalr
2>/dev
/null
511 # Prepare string for /etc/system-release.
512 local system_release
="${NAME} ${VERSION} (${BUILD_ARCH})"
514 case "${GIT_BRANCH}" in
516 system_release
="${system_release} - ${GIT_BRANCH}"
519 system_release
="${system_release} - Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
523 # Append -dirty tag for local changes
524 if [ "$(git status -s | wc -l)" != "0" ]; then
525 system_release
="${system_release}-dirty"
529 SYSTEM_RELEASE
="${system_release}"
531 # Decide on PAKFIRE_TREE
532 case "${GIT_BRANCH}" in
534 PAKFIRE_TREE
="stable"
537 PAKFIRE_TREE
="testing"
540 PAKFIRE_TREE
="unstable"
544 # Setup ccache cache size
545 enterchroot ccache
--max-size="${CCACHE_CACHE_SIZE}" >/dev
/null
549 # Install QEMU helper, if needed
552 local PATH
="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
554 PATH
="${PATH}" chroot
${LFS} env
-i \
559 SYSTEM_RELEASE
="${SYSTEM_RELEASE}" \
560 PAKFIRE_CORE
="${PAKFIRE_CORE}" \
561 PAKFIRE_TREE
="${PAKFIRE_TREE}" \
564 VERSION
="${VERSION}" \
567 TOOLS_DIR
="${TOOLS_DIR}" \
568 CONFIG_ROOT
="${CONFIG_ROOT}" \
569 CFLAGS
="${CFLAGS} ${HARDENING_CFLAGS}" \
570 CXXFLAGS
="${CXXFLAGS} ${HARDENING_CFLAGS}" \
571 RUSTFLAGS
="${RUSTFLAGS}" \
572 BUILDTARGET
="${BUILDTARGET}" \
573 CROSSTARGET
="${CROSSTARGET}" \
574 BUILD_ARCH
="${BUILD_ARCH}" \
575 BUILD_PLATFORM
="${BUILD_PLATFORM}" \
576 CCACHE_DIR
=/usr
/src
/ccache \
577 CCACHE_COMPRESS
="${CCACHE_COMPRESS}" \
578 CCACHE_COMPILERCHECK
="${CCACHE_COMPILERCHECK}" \
579 GOCACHE
="/usr/src/ccache/go" \
582 DEFAULT_PARALLELISM
="${DEFAULT_PARALLELISM}" \
583 SYSTEM_PROCESSORS
="${SYSTEM_PROCESSORS}" \
584 SYSTEM_MEMORY
="${SYSTEM_MEMORY}" \
591 if [ ! -e $BASEDIR/build
/usr
/src
/lfs
/ ]; then
592 exiterror
"No such file or directory: $BASEDIR/build/usr/src/lfs/"
595 echo "Entering to a shell inside LFS chroot, go out with exit"
596 local PS1
="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
598 if enterchroot bash
-i; then
602 exiterror
"chroot error"
606 lfsmakecommoncheck
() {
608 if [ ! -f $BASEDIR/lfs
/$1 ]; then
609 exiterror
"No such file or directory: $BASEDIR/$1"
612 # Print package name and version
615 # Check if this package is supported by our architecture.
616 # If no SUP_ARCH is found, we assume the package can be built for all.
617 if grep "^SUP_ARCH" ${BASEDIR}/lfs
/${1} >/dev
/null
; then
618 # Check if package supports ${BUILD_ARCH} or all architectures.
619 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
628 for i in $SKIP_PACKAGE_LIST
630 if [ "$i" == "$1" ]; then
636 echo -ne "`date -u '+%b %e %T'`: Building $
* " >> $LOGFILE
638 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
639 MESSAGE="$1\t " download >> $LOGFILE 2>&1
640 if [ $? -ne 0 ]; then
641 exiterror "Download error
in $1"
644 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
645 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
646 if [ $? -ne 0 ]; then
647 exiterror "md5sum error
in $1, check
file in cache or signature
"
654 lfsmakecommoncheck $*
655 [ $? == 1 ] && return 0
657 cd $BASEDIR/lfs && env -i \
658 PATH="${TOOLS_DIR}/ccache
/bin
:${TOOLS_DIR}/bin
:$PATH" \
659 CCACHE_DIR="${CCACHE_DIR}" \
660 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
661 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
663 CXXFLAGS="${CXXFLAGS}" \
664 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
665 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
666 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
669 TOOLS_DIR="${TOOLS_DIR}" \
670 CROSSTARGET="${CROSSTARGET}" \
671 BUILDTARGET="${BUILDTARGET}" \
672 BUILD_ARCH="${BUILD_ARCH}" \
673 BUILD_PLATFORM="${BUILD_PLATFORM}" \
674 LFS_BASEDIR="${BASEDIR}" \
677 install >> $LOGFILE 2>&1 &
679 if ! wait_until_finished $!; then
681 exiterror "Building $
*"
688 lfsmakecommoncheck $*
689 [ $? == 1 ] && return 0
694 ${EXTRA_PATH}bash -x -c "cd /usr
/src
/lfs
&& \
696 LFS_BASEDIR
=/usr
/src
install" \
699 if ! wait_until_finished $!; then
701 exiterror "Building $
*"
708 lfsmakecommoncheck $*
709 [ $? == 1 ] && return 0
714 bash -x -c "cd /usr
/src
/lfs
&& make -f $
* LFS_BASEDIR
=/usr
/src dist
" \
717 if ! wait_until_finished $!; then
719 exiterror "Packaging $
*"
725 wait_until_finished() {
728 local start_time=$(now)
731 if ${INTERACTIVE}; then
732 # Wait a little just in case the process
733 # has finished very quickly.
737 while kill -0 ${pid} 2>/dev/null; do
738 print_runtime $(( $(now) - ${start_time} ))
745 # Returns the exit code of the child process
749 if ! ${INTERACTIVE}; then
750 print_runtime $(( $(now) - ${start_time} ))
757 [ -e "${BASEDIR}/build
${TOOLS_DIR}/lib
/libpakfire_preload.so
" ] || return
759 local env="LD_PRELOAD
=${TOOLS_DIR}/lib
/libpakfire_preload.so
"
761 # Fake kernel version, because some of the packages do not compile
762 # with kernel 3.0 and later.
763 env="${env} UTS_RELEASE
=${KVER}-ipfire"
765 # Fake machine version.
766 env="${env} UTS_MACHINE
=${BUILD_ARCH}"
774 # Don't add anything if qemu is not used.
775 if ! qemu_is_required; then
779 # Set default qemu options
780 case "${BUILD_ARCH}" in
782 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
784 env="${env} QEMU_CPU
=${QEMU_CPU}"
789 #env="${env} QEMU_STRACE
=1"
795 local build_arch="${1}"
797 if [ -z "${build_arch}" ]; then
798 build_arch="${BUILD_ARCH}"
801 case "${HOST_ARCH},${build_arch}" in
802 x86_64,arm*|i?86,arm*|i?86,x86_64)
811 qemu_install_helper() {
812 # Do nothing, if qemu is not required
813 if ! qemu_is_required; then
817 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
818 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable.
"
821 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
822 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable.
"
826 if [ -z "${QEMU_TARGET_HELPER}" ]; then
827 exiterror "QEMU_TARGET_HELPER not
set"
830 # Check if the helper is already installed.
831 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
835 # Try to find a suitable binary that we can install
836 # to the build environment.
838 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
839 # file must exist and be executable.
840 [ -x "${file}" ] || continue
843 file_is_static "${file}" || continue
845 local dirname="${LFS}$
(dirname "${file}")"
846 mkdir -p "${dirname}"
848 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
852 exiterror "Could not
find a statically-linked QEMU emulator
: ${QEMU_TARGET_HELPER}"
855 qemu_find_build_helper_name() {
856 local build_arch="${1}"
859 case "${build_arch}" in
861 magic="7f454c4601010100000000000000000002002800
"
864 magic="7f454c4602010100000000000000000002003e00
"
868 [ -z "${magic}" ] && return 1
871 for file in /proc/sys/fs/binfmt_misc/*; do
872 # skip write only register entry
873 [ $(basename "${file}") = "register
" ] && continue
874 # Search for the file with the correct magic value.
875 grep -qE "^magic
${magic}$
" "${file}" || continue
877 local interpreter="$
(grep "^interpreter" "${file}" |
awk '{ print $2 }')"
879 [ -n "${interpreter}" ] || continue
880 [ "${interpreter:0:1}" = "/" ] || continue
881 [ -x "${interpreter}" ] || continue
883 echo "${interpreter}"
893 file ${file} 2>/dev/null | grep -q "statically linked
"
896 update_language_list() {
900 for lang in ${path}/*.po; do
901 lang="$
(basename "${lang}")"
903 done | sort -u > "${path}/LINGUAS
"
909 git shortlog --summary --numbered | while read -r commits name; do
911 done | grep -vE -e "^
(alpha197|morlix|root|ummeegge
)$
" -e "via Development$
" -e "@
" -e "#$"
914 update_contributors
() {
915 echo -n "Updating list of contributors"
917 local contributors
="$(contributors | paste -sd , - | sed -e "s
/,/&\\\\n
/g
")"
919 # Edit contributors into credits.cgi
920 local tmp
="$(mktemp)"
922 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
923 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
925 # Copy back modified content
926 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
934 CCACHE_CACHE_SIZE
="4G"
935 ENABLE_RAMDISK
="auto"
937 # Load configuration file
938 if [ -f .config
]; then
942 # TARGET_ARCH is BUILD_ARCH now
943 if [ -n "${TARGET_ARCH}" ]; then
944 BUILD_ARCH
="${TARGET_ARCH}"
948 # Get some information about the host system
949 SYSTEM_PROCESSORS
="$(system_processors)"
950 SYSTEM_MEMORY
="$(system_memory)"
952 if [ -n "${BUILD_ARCH}" ]; then
953 configure_build
"${BUILD_ARCH}"
955 configure_build
"default"
958 # Automatically enable/disable ramdisk usage
959 if [ "${ENABLE_RAMDISK}" = "auto" ]; then
960 # Enable only when the host system has 4GB of RAM or more
961 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
968 case "${BUILD_ARCH}:${HOST_ARCH}" in
975 i586
:i586|i586
:i686|i586
:x86_64
)
983 arvm7hl
:armv7hl|armv7hl
:armv7l
)
987 armv5tel
:armv5tel|armv5tel
:armv5tejl|armv5tel
:armv6l|armv5tel
:armv7l|armv5tel
:aarch64
)
996 exiterror
"Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
998 local gcc
=$
(type -p gcc
)
999 if [ -z "${gcc}" ]; then
1000 exiterror
"Could not find GCC. You will need a working build enviroment in order to build the toolchain."
1003 # Check ${TOOLS_DIR} symlink
1004 if [ -h "${TOOLS_DIR}" ]; then
1005 rm -f "${TOOLS_DIR}"
1008 if [ ! -e "${TOOLS_DIR}" ]; then
1009 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
1012 if [ ! -h "${TOOLS_DIR}" ]; then
1013 exiterror
"Could not create ${TOOLS_DIR} symbolic link"
1016 LOGFILE
="$BASEDIR/log/_build.toolchain.log"
1020 lfsmake1 ccache PASS
=1
1021 lfsmake1 binutils PASS
=1
1023 lfsmake1 linux KCFG
="-headers"
1026 lfsmake1 binutils PASS
=2
1029 lfsmake1 ccache PASS
=2
1056 lfsmake1 fake-environ
1058 lfsmake1 cleanup-toolchain
1062 LOGFILE
="$BASEDIR/log/_build.base.log"
1065 lfsmake2 linux KCFG
="-headers"
1069 lfsmake2 cleanup-toolchain
1091 lfsmake2 readline-compat
1095 lfsmake2 pcre-compat
1131 LOGFILE
="$BASEDIR/log/_build.ipfire.log"
1134 lfsmake2 initscripts
1137 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG
='-sse2'
1141 lfsmake2 libusb-compat
1147 lfsmake2 linux-firmware
1148 lfsmake2 dvb-firmwares
1149 lfsmake2 xr819-firmware
1150 lfsmake2 zd1211-firmware
1151 lfsmake2 rpi-firmware
1152 lfsmake2 intel-microcode
1153 lfsmake2 pcengines-apu-firmware
1155 lfsmake2 u-boot MKIMAGE
=1
1161 lfsmake2 multipath-tools
1164 lfsmake2 libnfnetlink
1165 lfsmake2 libnetfilter_queue
1166 lfsmake2 libnetfilter_conntrack
1167 lfsmake2 libnetfilter_cthelper
1168 lfsmake2 libnetfilter_cttimeout
1173 case "${BUILD_ARCH}" in
1175 lfsmake2 linux KCFG
=""
1176 # lfsmake2 backports KCFG=""
1177 # lfsmake2 e1000e KCFG=""
1178 # lfsmake2 igb KCFG=""
1179 # lfsmake2 ixgbe KCFG=""
1180 lfsmake2 xtables-addons KCFG
=""
1181 lfsmake2 linux-initrd KCFG
=""
1184 # x86-pae (Native and new XEN) kernel build
1185 lfsmake2 linux KCFG
="-pae"
1186 # lfsmake2 backports KCFG="-pae"
1187 # lfsmake2 e1000e KCFG="-pae"
1188 # lfsmake2 igb KCFG="-pae"
1189 # lfsmake2 ixgbe KCFG="-pae"
1190 lfsmake2 xtables-addons KCFG
="-pae"
1191 lfsmake2 linux-initrd KCFG
="-pae"
1194 lfsmake2 linux KCFG
=""
1195 # lfsmake2 backports KCFG=""
1196 # lfsmake2 e1000e KCFG=""
1197 # lfsmake2 igb KCFG=""
1198 # lfsmake2 ixgbe KCFG=""
1199 lfsmake2 xtables-addons KCFG
=""
1200 lfsmake2 linux-initrd KCFG
=""
1204 # arm multi platform (Panda, Wandboard ...) kernel build
1205 lfsmake2 linux KCFG
="-multi"
1206 # lfsmake2 backports KCFG="-multi"
1207 # lfsmake2 e1000e KCFG="-multi"
1208 # lfsmake2 igb KCFG="-multi"
1209 # lfsmake2 ixgbe KCFG="-multi"
1210 lfsmake2 xtables-addons KCFG
="-multi"
1211 lfsmake2 linux-initrd KCFG
="-multi"
1214 lfsmake2 xtables-addons USPACE
="1"
1215 lfsmake2 libgpg-error
1244 lfsmake2 ca-certificates
1252 lfsmake2 libjpeg-compat
1273 lfsmake2 web-user-interface
1284 lfsmake2 reiserfsprogs
1290 lfsmake2 ez-ipupdate
1294 lfsmake2 GD-TextUtil
1295 lfsmake2 perl-Device-SerialPort
1296 lfsmake2 perl-Device-Modem
1297 lfsmake2 perl-Apache-Htpasswd
1303 lfsmake2 conntrack-tools
1307 lfsmake2 l7-protocols
1315 lfsmake2 perl-Switch
1316 lfsmake2 HTML-Tagset
1317 lfsmake2 HTML-Parser
1318 lfsmake2 HTML-Template
1319 lfsmake2 Compress-Zlib
1321 lfsmake2 Digest-SHA1
1322 lfsmake2 Digest-HMAC
1323 lfsmake2 libwww-perl
1325 lfsmake2 Net-IPv4Addr
1328 lfsmake2 IO-Socket-SSL
1329 lfsmake2 Unix-Syslog
1333 lfsmake2 Convert-TNEF
1334 lfsmake2 Convert-UUlib
1335 lfsmake2 Archive-Tar
1336 lfsmake2 Archive-Zip
1337 lfsmake2 Text-Tabs
+Wrap
1338 lfsmake2 Locale-Country
1340 lfsmake2 Crypt-PasswdMD5
1342 lfsmake2 python-setuptools
1343 lfsmake2 python-clientform
1344 lfsmake2 python-mechanize
1345 lfsmake2 python-feedparser
1346 lfsmake2 python-rssdler
1347 lfsmake2 python-inotify
1348 lfsmake2 python-docutils
1349 lfsmake2 python-daemon
1350 lfsmake2 python-ipaddress
1353 lfsmake2 geoip-database
1357 lfsmake2 dejavu-fonts-ttf
1358 lfsmake2 ubuntu-font-family
1376 lfsmake2 ids-ruleset-sources
1396 lfsmake2 ghostscript
1399 lfsmake2 cups-filters
1400 lfsmake2 epson-inkjet-printer-escpr
1409 lfsmake2 bridge-utils
1410 lfsmake2 smartmontools
1415 lfsmake2 cyrus-imapd
1417 lfsmake2 perl-NetAddr-IP
1418 lfsmake2 spamassassin
1419 lfsmake2 perl-Net-LibIDN
1453 lfsmake2 pcmciautils
1462 lfsmake2 python-pyparsing
1463 lfsmake2 spice-protocol
1466 lfsmake2 libusbredir
1472 lfsmake2 nagios_nrpe
1473 lfsmake2 nagios-plugins
1475 lfsmake2 observium-agent
1482 lfsmake2 vdr_streamdev
1483 lfsmake2 vdr_epgsearch
1488 lfsmake2 icegenerator
1490 lfsmake2 libmpdclient
1492 lfsmake2 perl-Net-CIDR-Lite
1493 lfsmake2 perl-Net-SMTP-SSL
1494 lfsmake2 perl-MIME-Base64
1495 lfsmake2 perl-Authen-SASL
1496 lfsmake2 perl-MIME-Lite
1497 lfsmake2 perl-Email-Date-Format
1499 lfsmake2 squidclamav
1502 lfsmake2 wpa_supplicant
1508 lfsmake2 cpufrequtils
1516 lfsmake2 streamripper
1520 lfsmake2 perl-gettext
1521 lfsmake2 perl-Sort-Naturally
1524 lfsmake2 perl-DBD-SQLite
1525 lfsmake2 perl-File-ReadBackwards
1526 lfsmake2 openvmtools
1535 lfsmake2 usb_modeswitch
1536 lfsmake2 usb_modeswitch_data
1546 lfsmake2 u-boot-kirkwood
1547 lfsmake2 u-boot-friendlyarm
1548 lfsmake2 python-typing
1549 lfsmake2 python-m2crypto
1550 lfsmake2 wireless-regdb
1553 lfsmake2 python-distutils-extra
1554 lfsmake2 python-lzma
1555 lfsmake2 python-progressbar
1556 lfsmake2 python-xattr
1558 lfsmake2 python3-setuptools
1559 lfsmake2 python3-setuptools-scm
1560 lfsmake2 python3-six
1561 lfsmake2 python3-dateutil
1562 lfsmake2 python3-jmespath
1563 lfsmake2 python3-colorama
1564 lfsmake2 python3-docutils
1565 lfsmake2 python3-yaml
1566 lfsmake2 python3-s3transfer
1567 lfsmake2 python3-rsa
1568 lfsmake2 python3-pyasn1
1569 lfsmake2 python3-botocore
1570 lfsmake2 python3-llfuse
1571 lfsmake2 python3-msgpack
1573 lfsmake2 transmission
1586 lfsmake2 libstatgrab
1588 lfsmake2 check_mk_agent
1594 lfsmake2 ipfire-netboot
1600 lfsmake2 perl-Carp-Clan
1601 lfsmake2 perl-Date-Calc
1602 lfsmake2 perl-Date-Manip
1603 lfsmake2 perl-File-Tail
1604 lfsmake2 perl-TimeDate
1612 lfsmake2 perl-Font-TTF
1613 lfsmake2 perl-IO-String
1614 lfsmake2 perl-PDF-API2
1615 lfsmake2 squid-accounting
1618 lfsmake2 perl-Text-CSV_XS
1628 lfsmake2 util-macros
1629 lfsmake2 libpciaccess
1633 lfsmake2 perl-common-sense
1634 lfsmake2 perl-inotify2
1635 lfsmake2 perl-Net-IP
1638 lfsmake2 mdns-repeater
1640 lfsmake2 nss-myhostname
1642 lfsmake2 shairport-sync
1645 lfsmake2 spectre-meltdown-checker
1646 lfsmake2 zabbix_agentd
1648 lfsmake2 firmware-update
1650 lfsmake2 geoip-generator
1651 lfsmake2 speedtest-cli
1653 lfsmake2 amazon-ssm-agent
1657 # Run installer scripts one by one
1658 LOGFILE
="$BASEDIR/log/_build.installer.log"
1662 # use toolchain bash for chroot to strip
1663 EXTRA_PATH
=${TOOLS_DIR}/bin
/ lfsmake2 strip
1667 LOGFILE
="$BASEDIR/log/_build.packages.log"
1669 echo "... see detailed log in _build.*.log files" >> $LOGFILE
1672 # Generating list of packages used
1673 print_line
"Generating packages list from logs"
1674 rm -f $BASEDIR/doc
/packages-list
1675 for i
in `ls -1tr $BASEDIR/log/[^_]*`; do
1676 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
1677 echo "* `basename $i`" >>$BASEDIR/doc
/packages-list
1680 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc
/packages-list.txt
1681 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
1682 $BASEDIR/doc
/packages-list |
sort >> $BASEDIR/doc
/packages-list.txt
1683 rm -f $BASEDIR/doc
/packages-list
1684 # packages-list.txt is ready to be displayed for wiki page
1689 [ -z $GIT_TAG ] || LAST_TAG
=$GIT_TAG
1690 [ -z $LAST_TAG ] || EXT
="$LAST_TAG..HEAD"
1691 git log
-n 500 --no-merges --pretty=medium
--shortstat $EXT > $BASEDIR/doc
/ChangeLog
1693 # Create images for install
1696 # Check if there is a loop device for building in virtual environments
1697 modprobe loop
2>/dev
/null
1698 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev
/loop
/0 ] ||
[ -e /dev
/loop0
] ||
[ -e "/dev/loop-control" ]); then
1699 lfsmake2 flash-images
1702 mv $LFS/install
/images
/{*.iso
,*.img.xz
,*.bz2
} $BASEDIR >> $LOGFILE 2>&1
1707 mv $LFS/install
/images
/*.bz2
$BASEDIR >> $LOGFILE 2>&1
1711 # remove not useable iso on armv5tel (needed to build flash images)
1712 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
1714 for i
in `ls *.bz2 *.img.xz *.iso`; do
1721 rm -rf $BASEDIR/build
/tmp
/*
1727 lfsmake2 core-updates
1730 for i
in $
(find $BASEDIR/config
/rootfiles
/packages
{/${BUILD_ARCH},} -maxdepth 1 -type f
); do
1732 if [ -e $BASEDIR/lfs
/$i ]; then
1739 test -d $BASEDIR/packages || mkdir
$BASEDIR/packages
1740 mv -f $LFS/install
/packages
/* $BASEDIR/packages
>> $LOGFILE 2>&1
1741 rm -rf $BASEDIR/build
/install
/packages
/*
1744 while [ $# -gt 0 ]; do
1747 configure_build
"${1#--target=}"
1750 exiterror
"Unknown configuration option: ${1}"
1753 # Found a command, so exit options parsing.
1760 # See what we're supposed to do
1766 ${INTERACTIVE} && clear
1768 PACKAGE
=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
1769 #only restore on a clean disk
1770 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
1771 if [ ! -n "$PACKAGE" ]; then
1772 print_build_stage
"Full toolchain compilation"
1776 PACKAGENAME
=${PACKAGE%.tar.xz}
1777 print_build_stage
"Packaged toolchain compilation"
1778 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
1782 exiterror
"$PACKAGENAME md5 did not match, check downloaded package"
1789 print_build_stage
"Building LFS"
1792 print_build_stage
"Building IPFire"
1795 print_build_stage
"Building installer"
1798 print_build_stage
"Building packages"
1801 print_build_stage
"Checking Logfiles for new Files"
1804 tools
/checknewlog.pl
1805 tools
/checkrootfiles
1808 print_build_summary $
(( $
(now
) - ${START_TIME} ))
1811 # enter a shell inside LFS chroot
1812 # may be used to changed kernel settings
1817 print_line
"Cleaning build directory..."
1819 for i
in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1820 $LOSETUP -d $i 2>/dev
/null
1822 for i
in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1826 for i
in `seq 0 7`; do
1827 if ( losetup
/dev
/loop
${i} 2>/dev
/null |
grep -q "/install/images" ); then
1828 umount
/dev
/loop
${i} 2>/dev
/null
;
1829 losetup
-d /dev
/loop
${i} 2>/dev
/null
;
1832 rm -rf $BASEDIR/build
1833 rm -rf $BASEDIR/cdrom
1834 rm -rf $BASEDIR/packages
1836 if [ -h "${TOOLS_DIR}" ]; then
1837 rm -f "${TOOLS_DIR}"
1839 rm -f $BASEDIR/ipfire-
*
1843 # Build the docker image if it does not exist, yet
1844 if ! docker images
-a |
grep -q ^ipfire-builder
; then
1845 if docker build
-t ipfire-builder
${BASEDIR}/tools
/docker
; then
1853 # Run the container and enter a shell
1854 docker run
-it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash
-l
1857 if [ ! -d $BASEDIR/cache
]; then
1858 mkdir
$BASEDIR/cache
1860 mkdir
-p $BASEDIR/log
1861 echo -e "${BOLD}Preload all source files${NORMAL}" |
tee -a $LOGFILE
1864 for c
in `seq $MAX_RETRIES`; do
1865 if (( FINISHED
==1 )); then
1871 if [ -f "$i" -a "$i" != "Config" ]; then
1872 lfsmakecommoncheck
${i} ||
continue
1874 make -s -f $i LFS_BASEDIR
=$BASEDIR BUILD_ARCH
="${BUILD_ARCH}" \
1875 MESSAGE
="$i\t ($c/$MAX_RETRIES)" download
>> $LOGFILE 2>&1
1876 if [ $?
-ne 0 ]; then
1880 if [ $c -eq 1 ]; then
1887 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
1890 if [ -f "$i" -a "$i" != "Config" ]; then
1891 lfsmakecommoncheck
${i} > /dev
/null ||
continue
1892 make -s -f $i LFS_BASEDIR
=$BASEDIR BUILD_ARCH
="${BUILD_ARCH}" \
1893 MESSAGE
="$i\t " md5
>> $LOGFILE 2>&1
1894 if [ $?
-ne 0 ]; then
1895 echo -ne "MD5 difference in lfs/$i"
1901 if [ $ERROR -eq 0 ]; then
1902 echo -ne "${BOLD}all files md5sum match${NORMAL}"
1905 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
1908 cd - >/dev
/null
2>&1
1912 ${INTERACTIVE} && clear
1915 print_build_stage
"Toolchain compilation (${BUILD_ARCH})"
1917 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" |
tee -a $LOGFILE
1918 test -d $BASEDIR/cache
/toolchains || mkdir
-p $BASEDIR/cache
/toolchains
1919 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build
/${TOOLS_DIR} build
/bin
/sh log | xz
${XZ_OPT} \
1920 > cache
/toolchains
/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.
tar.xz
1921 md5sum cache
/toolchains
/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.
tar.xz \
1922 > cache
/toolchains
/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
1926 # arbitrary name to be updated in case of new toolchain package upload
1927 PACKAGE
=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
1928 if [ ! -f $BASEDIR/cache
/toolchains
/$PACKAGE.
tar.xz
]; then
1929 URL_TOOLCHAIN
=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
1930 test -d $BASEDIR/cache
/toolchains || mkdir
-p $BASEDIR/cache
/toolchains
1931 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" |
tee -a $LOGFILE
1932 cd $BASEDIR/cache
/toolchains
1933 wget
-U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.
tar.xz
$URL_TOOLCHAIN/$PACKAGE.md5
>& /dev
/null
1934 if [ $?
-ne 0 ]; then
1935 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" |
tee -a $LOGFILE
1937 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
1938 echo "`date -u '+%b %e %T'`: toolchain md5 ok" |
tee -a $LOGFILE
1940 exiterror
"$PACKAGE.md5 did not match, check downloaded package"
1944 echo "Toolchain is already downloaded. Exiting..."
1949 if [ -z $IPFIRE_USER ]; then
1950 echo -n "You have to setup IPFIRE_USER first. See .config for details."
1955 URL_SOURCE
=$
(grep URL_SOURCE lfs
/Config |
awk '{ print $3 }')
1956 REMOTE_FILES
=$
(echo "ls -1" | sftp
-C ${IPFIRE_USER}@
${URL_SOURCE})
1958 for file in ${BASEDIR}/cache
/*; do
1959 [ -d "${file}" ] && continue
1960 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
1961 NEW_FILES
="$NEW_FILES $file"
1963 [ -n "$NEW_FILES" ] && scp
-2 $NEW_FILES ${IPFIRE_USER}@
${URL_SOURCE}
1969 echo -ne "Checking the translations for missing or obsolete strings..."
1970 chmod 755 $BASEDIR/tools
/{check_strings.pl
,sort_strings.pl
,check_langs.sh
}
1971 $BASEDIR/tools
/sort_strings.pl en
1972 $BASEDIR/tools
/sort_strings.pl de
1973 $BASEDIR/tools
/sort_strings.pl fr
1974 $BASEDIR/tools
/sort_strings.pl es
1975 $BASEDIR/tools
/sort_strings.pl pl
1976 $BASEDIR/tools
/sort_strings.pl ru
1977 $BASEDIR/tools
/sort_strings.pl
nl
1978 $BASEDIR/tools
/sort_strings.pl
tr
1979 $BASEDIR/tools
/sort_strings.pl it
1980 $BASEDIR/tools
/check_strings.pl en
> $BASEDIR/doc
/language_issues.en
1981 $BASEDIR/tools
/check_strings.pl de
> $BASEDIR/doc
/language_issues.de
1982 $BASEDIR/tools
/check_strings.pl fr
> $BASEDIR/doc
/language_issues.fr
1983 $BASEDIR/tools
/check_strings.pl es
> $BASEDIR/doc
/language_issues.es
1984 $BASEDIR/tools
/check_strings.pl es
> $BASEDIR/doc
/language_issues.pl
1985 $BASEDIR/tools
/check_strings.pl ru
> $BASEDIR/doc
/language_issues.ru
1986 $BASEDIR/tools
/check_strings.pl
nl > $BASEDIR/doc
/language_issues.
nl
1987 $BASEDIR/tools
/check_strings.pl
tr > $BASEDIR/doc
/language_issues.
tr
1988 $BASEDIR/tools
/check_strings.pl it
> $BASEDIR/doc
/language_issues.it
1989 $BASEDIR/tools
/check_langs.sh
> $BASEDIR/doc
/language_missings
1992 echo -ne "Updating language lists..."
1993 update_language_list
${BASEDIR}/src
/installer
/po
1994 update_language_list
${BASEDIR}/src
/setup
/po
1997 update-contributors
)
2001 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors}"
2002 cat doc
/make.sh-usage